<template>
  <v-container>
    <v-dialog
      v-model="showDialog"
      v-if="processType === 'delete'"
      max-width="530"
      persistent
    >
      <v-card>
        <v-card-title class="headline">
          Are you sure you want to delete
          {{ item ? item.name : "" }} ?
        </v-card-title>
        <v-card-actions>
          <UIAlert
            class="mt-4"
            v-if="hasRequestError"
            v-bind:isSuccessful="!hasRequestError"
            v-bind:message="$store.state.application.httpErrorMessage"
          />
          <v-spacer></v-spacer>
          <v-btn
            color="blue darken-1"
            text
            @click="
              $emit('child-object', {
                closeDialog: true,
                orgaChanged: false
              })
            "
            >close</v-btn
          >
          <v-btn color="blue darken-1" text @click="confirmDeletion">yes</v-btn>
        </v-card-actions>
      </v-card>
    </v-dialog>
    <v-dialog v-model="showDialog" max-width="70vw" persistent v-else>
      <v-card>
        <v-card-title v-if="processType === 'add'"
          >Add Organisation</v-card-title
        >
        <v-card-title v-else>Edit {{ item?.name }}</v-card-title>
        <v-divider></v-divider>
        <v-container>
          <v-row no-getters align="center" class="flex-nowrap">
            <v-col cols="7" class="align-self-start">
              <v-form v-model="valid" ref="addForm" class="col col-12">
                <div class="mb-4">General</div>
                <div v-if="organisations && processType !== 'edit'" class="mt-8">
                  <v-select
                      dense
                      clearable
                      return-object
                      required
                      label="Sub-organisation to:"
                      :rules="parentOrgaRules"
                      :items="organisations"
                      item-text="name"
                      item-value="organisation_id"
                      hint="The parent of the added organisation"
                      persistent-hint
                      v-model="parentOrga"
                  >
                  </v-select>
                </div>
                <div v-if="!$store.getters['user/isOrgaAdmin']" class="mt-8">
                  <v-select
                      dense
                      clearable
                      return-object
                      required
                      :items="tenants"
                      :rules="tenantRules"
                      item-text="name"
                      item-value="tenant_id"
                      hint="The tenant to which the organisation belongs"
                      persistent-hint
                      label="Tenant(s)"
                      v-model="selectedTenants"
                      multiple
                      small-chips
                      deletable-chips
                  >
                    <template
                        v-slot:prepend-inner
                        v-if="fixedTenants && fixedTenants.length"
                    >
                      <div
                          v-for="tenant in fixedTenants"
                          :key="tenant.tenant_id"
                      >
                        <v-chip small>{{ tenant.name }}</v-chip>
                      </div>
                    </template>
                  </v-select>
                </div>
                <div v-if="!$store.getters['user/isOrgaAdmin']" class="mt-8">
                  <v-select
                      dense
                      clearable
                      return-object
                      :items="tags"
                      item-text="name"
                      item-value="organisation_tag_id"
                      hint="The tags of the organisation"
                      persistent-hint
                      label="Tag(s)"
                      v-model="selectedTags"
                      multiple
                      small-chips
                      deletable-chips
                  ></v-select>
                </div>
                <div class="mt-8">
                  <v-text-field
                      label="Organisation name"
                      v-model="orgaName"
                      required
                      :rules="[v => !!v || 'Name is required']"
                  >
                  </v-text-field>
                </div>
              </v-form>
            </v-col>
            <v-divider vertical></v-divider>
            <v-col cols="5" class="align-self-start">
              <v-form v-model="mailDomainValid" ref="mailDomainForm" class="col col-12">
                <div class="mb-4">E-Mail Domains</div>
                <div class="mt-4">
                  <v-text-field
                      label="Add an e-mail domain"
                      v-model="mailDomainInput"
                      :rules="[
                          v => /^([a-z0-9]+([\-\.]{1}[a-z0-9]+)*\.[a-z]{2,6}(:[0-9]{1,5})?(\/.*)?)$/.test(v) || 'Domain is not valid',
                          ]"
                  >
                    <template #append-outer>
                      <v-btn
                          small
                          :disabled="!mailDomainValid || (mailDomainInput != null && mailDomainInput.length < 1)"
                          @click="addMailDomain(); mailDomainForm.reset();"
                        >
                        Add
                      </v-btn>
                    </template>
                  </v-text-field>
                  <div v-if="orgaMailDomains.length">
                    <ul>
                      <li v-for="domain in orgaMailDomains" :key="domain">
                        {{ domain }}
                        <v-btn
                            icon
                            color="error"
                            x-small
                            @click="removeMailDomain(domain);"
                        >
                          <v-icon>mdi-delete</v-icon>
                        </v-btn>
                      </li>
                    </ul>
                  </div>
                  <div class="text-center grey--text mt-8" v-else-if="!orgaParentMailDomains">
                    Currently no e-mail domain assigned.<br>
                    E-mail addresses for related contacts are entered in a regular text field.
                  </div>
                  <div v-for="(parentDomains, parentName) in orgaParentMailDomains" :key="parentName">
                    <ul v-for="parentDomain in parentDomains" :key="parentDomain">
                      <li class="grey--text">
                        {{ parentDomain }}
                        <v-chip x-small label>
                          <v-icon x-small class="mr-1">mdi-source-merge</v-icon>
                          {{ parentName }}
                        </v-chip>
                      </li>
                    </ul>
                  </div>
                </div>
              </v-form>
            </v-col>
          </v-row>
        </v-container>
        <v-divider></v-divider>
        <v-card-actions>
          <UIAlert
            class="mt-4"
            v-if="hasRequestError"
            v-bind:isSuccessful="!hasRequestError"
            v-bind:message="$store.state.application.httpErrorMessage"
          />
          <v-spacer></v-spacer>
          <v-btn
            color="blue darken-1"
            text
            @click="
              addForm.reset();
              mailDomainForm.reset();
              $emit('child-object', { closeDialog: true, orgaChanged: false });
            "
          >
            Cancel
          </v-btn>
          <v-btn
            v-if="processType === 'add'"
            color="blue darken-1"
            text
            :disabled="!valid"
            @click="addOrganisation()"
          >
            Add
          </v-btn>
          <v-btn
            v-else
            color="blue darken-1"
            text
            :disabled="!valid"
            @click="confirmEditing()"
          >
            save
          </v-btn>
        </v-card-actions>
      </v-card>
    </v-dialog>
  </v-container>
</template>

<script setup lang="ts">
/*
 * This file is Free Software under GNU Affero General Public License v >= 3.0
 * without warranty, see README.md and license for details.
 *
 * SPDX-License-Identifier: AGPL-3.0-or-later
 *
 * SPDX-FileCopyrightText: 2020 nic.at GmbH <https://nic.at>
 * Software-Engineering: 2020 Intevation GmbH <https://intevation.de>
 *
 * Author(s):
 * 2021, 2022 Fadi Abbud <fadi.abbud@intevation.de>
 */
import { HTTP } from "@/lib/http";
import { useForm } from "@/lib/use-form";
import { useNotification } from "@/lib/use-notification";
import { useOrganisation } from "@/lib/use-organisation";
import { useStore } from "@/store";
import { computed, defineAsyncComponent, onMounted, ref } from "vue";
const UIAlert = defineAsyncComponent(() =>
  import("@/components/ui/UIAlert.vue")
);

const props = defineProps({
  processType: String,
  item: Object
});

const emit = defineEmits(["child-object"]);

// Notifications
const { hasRequestError } = useNotification();
// Organisations
const { organisations, isOrgLoading, getOrganisations } = useOrganisation();
const store = useStore();
const showDialog = true;
const { form: addForm, valid } = useForm();
const { form: mailDomainForm, mailDomainValid } = useForm();
const selectedTags = ref();
const parentOrga = ref();
const orgaName = ref();
const orgaMailDomains = ref([]);
const orgaParentMailDomains = ref([]);
const mailDomainInput = ref("");
const parentOrgaRules = computed(() => {
  if (store.getters["user/isOrgaAdmin"]) {
    return [v => !!v || "Selecting Parent organisation is required"];
  }
  if (selectedTenants.value && selectedTenants.value.length) {
    return [];
  } else {
    return [
      v =>
        !!v || "Selecting either Tenant(s) or parent organisation is required"
    ];
  }
});
// Tenants
const tenantRules = computed(() => {
  if (props.processType === "add") {
    if (parentOrga.value && parentOrga.value.name !== "") {
      return [];
    } else {
      return [
        v =>
          !!(v && v.length) ||
          "Selecting either Tenant(s) or parent organisation is required"
      ];
    }
  } else {
    return [
      v =>
        !!(v && v.length) ||
        fixedTenants.value.length > 0 ||
        "Selecting a tenant is required"
    ];
  }
});
const selectedTenants = ref();
const tenants = computed(() => {
  return store.getters["user/getUserTenants"];
});

// Organisation Tags
const tags = computed(() => {
  return store.state.organisation.organisationTags;
});
const getTags = () => {
  isOrgLoading.value = true;
  store
    .dispatch("organisation/loadOrganisationTags")
    .then()
    .catch(() => {
      hasRequestError.value = true;
    })
    .finally(() => {
      isOrgLoading.value = false;
    });
};
onMounted(() => {
  // Load organisations only for add process as these is not relevant for "edit"
  if (props.processType === "add") {
    getOrganisations();
  }
  if (!store.getters["user/isOrgaAdmin"]) {
    getTags();
  }
  setInitialValues();
});
const fixedTenants = computed(() => {
  if (props.processType === "edit") {
    if (props.item) {
      if (props.item.tenants.length && tenants.value.length) {
        return props.item.tenants.filter(
          t => !tenants.value.some(t2 => t.tenant_id === t2.tenant_id)
        );
      }
    }
  }
  return [];
});
const setInitialValues = () => {
  if (props.processType === "edit") {
    orgaName.value = props.item ? props.item.name : "";
    orgaMailDomains.value = props.item?.mail_domains[props.item.name];
    orgaParentMailDomains.value = JSON.parse(JSON.stringify(props.item?.mail_domains));
    delete orgaParentMailDomains.value[props.item.name];

    if (!store.getters["user/isOrgaAdmin"]) {
      selectedTags.value = props.item?.tags;
      selectedTenants.value = props.item?.tenants.filter(t =>
        tenants.value.some(t2 => t2.tenant_id === t.tenant_id)
      );
    }
  }
  if (props.processType === "add") {
    // For orgaadmin the default parent organisation for the added one
    // is the current organisation of the user
    if (store.getters["user/isOrgaAdmin"]) {
      parentOrga.value = store.state.organisation.organisations.filter(
        o => store.state.user.selectedNode.node_id === o.organisation_id
      )[0];
    } else {
      parentOrga.value = null;
    }
  }
};
// Edit organisation
const confirmEditing = () => {
  isOrgLoading.value = true;
  const payload = {};
  payload["name"] = orgaName.value;
  if (selectedTags.value && selectedTags.value.length) {
    payload["tags"] = selectedTags.value.map(t => t["organisation_tag_id"]);
  }

  // Only set tenant id's for allowed roles "portaladmin" and "tenantadmin"
  if (!store.getters["user/isOrgaAdmin"] && selectedTenants.value && selectedTenants.value.length) {
    payload["tenant_ids"] = selectedTenants.value.map(t => t["tenant_id"]);
  }

  payload["mail_domains"] = orgaMailDomains.value;

  HTTP.put("/organisations/" + props.item?.organisation_id, payload)
    .then(() => {
      emit("child-object", { closeDialog: true, orgaChanged: true });
    })
    .catch(() => {
      hasRequestError.value = true;
    })
    .finally(() => {
      isOrgLoading.value = false;
    });
};
// Add Organisation
const addOrganisation = () => {
  isOrgLoading.value = true;
  const payload = {};
  let isSubOrga = false;
  if (parentOrga.value && parentOrga.value.organisation_id) {
    payload["parent_id"] = parentOrga.value.organisation_id;
    isSubOrga = true;
  }
  if (store.getters["user/isTenantAdmin"]) {
    if (selectedTenants.value && selectedTenants.value.length) {
      payload["tenant_ids"] = selectedTenants.value.map(t => t["tenant_id"]);
    } else if (!isSubOrga) {
      payload["tenant_ids"] = [store.state.user.selectedNode.node_id];
    }
  }
  if (
    store.getters["user/isPortalAdmin"] &&
    selectedTenants.value &&
    selectedTenants.value.length
  ) {
    payload["tenant_ids"] = selectedTenants.value.map(t => t["tenant_id"]);
  }
  if (
    !store.getters["user/isOrgaAdmin"] &&
    selectedTags.value &&
    selectedTags.value.length
  ) {
    payload["tags"] = selectedTags.value.map(t => t["organisation_tag_id"]);
  }
  payload["name"] = orgaName.value;
  payload["mail_domains"] = orgaMailDomains.value;
  HTTP.post("/organisations", payload)
    .then(() => {
      emit("child-object", { closeDialog: true, orgaChanged: true });
    })
    .catch(() => {
      //TODO: show error message
      hasRequestError.value = true;
    })
    .finally(() => {
      isOrgLoading.value = false;
    });
};
// Delete organisation
const confirmDeletion = () => {
  isOrgLoading.value = true;
  HTTP.delete("/organisations/" + props.item?.organisation_id)
    .then(() => {
      emit("child-object", { closeDialog: true, orgaChanged: true });
    })
    .catch(() => {
      hasRequestError.value = true;
    })
    .finally(() => {
      isOrgLoading.value = false;
    });
};

const addMailDomain = () => {
  if (! orgaMailDomains.value.includes(mailDomainInput.value)) {
    orgaMailDomains.value.push(mailDomainInput.value);
  }
}

const removeMailDomain = (removeDomain) => {
  orgaMailDomains.value = orgaMailDomains.value.filter(mailDomain => mailDomain !== removeDomain);
}

</script>
